using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using System.Drawing.Drawing2D;

namespace ClientControls
{
	/// <summary>
	/// Summary description for AllyState.
	/// </summary>
	public class AllyState : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public enum STATE
		{
			NONE = 0,
			LEFT = 1,
			RIGHT = 2,
			BOTH = 3
		}

		private STATE m_State = STATE.NONE;
		public STATE State
		{
			get
			{
				return m_State;
			}
		}
		static private ImageList imageList = null;
		public AllyState()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			if ( imageList == null )
			{
				imageList = new ImageList();
				imageList.ImageSize = new Size(25, 25);
				Stream strm = Assembly.GetExecutingAssembly().GetManifestResourceStream("ClientControls.state1copy.gif");
				imageList.Images.Add(System.Drawing.Image.FromStream(strm));
				strm = Assembly.GetExecutingAssembly().GetManifestResourceStream("ClientControls.state2copy.gif");
				imageList.Images.Add(System.Drawing.Image.FromStream(strm));
				strm = Assembly.GetExecutingAssembly().GetManifestResourceStream("ClientControls.state3copy.gif");
				imageList.Images.Add(System.Drawing.Image.FromStream(strm));
				strm = Assembly.GetExecutingAssembly().GetManifestResourceStream("ClientControls.state4copy.gif");
				imageList.Images.Add(System.Drawing.Image.FromStream(strm));			
			}

			SetStyle(ControlStyles.UserPaint | ControlStyles.ResizeRedraw | ControlStyles.AllPaintingInWmPaint, true);
			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// AllyState
			// 
			this.Name = "AllyState";
			this.Size = new System.Drawing.Size(25, 25);
			this.SizeChanged += new System.EventHandler(this.AllyState_SizeChanged);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.AllyState_Paint);

		}
		#endregion

		public void AlliedTo(bool state)
		{
			if ( state )
				m_State |= STATE.LEFT;
			else
				m_State &= ~STATE.LEFT;
			Invalidate();
		}

		public void AlliedFrom(bool state)
		{
			if ( state )
				m_State |= STATE.RIGHT;
			else
				m_State &= ~STATE.RIGHT;
			Invalidate();
		}

		private void AllyState_SizeChanged(object sender, System.EventArgs e)
		{
//			Invalidate();
		}

		private void AllyState_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if ( Size.Width > 25 )
				e.Graphics.DrawImageUnscaled(imageList.Images[(int)m_State], Size.Width/2-12, 0, 25, 25);
			else
				e.Graphics.DrawImageUnscaled(imageList.Images[(int)m_State], 0, 0, 25, 25);
		}
	}
}
