using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using System.Text.RegularExpressions;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace SpringClient
{
	/// <summary>
	/// Summary description for BattleHost.
	/// </summary>
	public class BattleHost : System.Windows.Forms.Form
	{
		private MapSelector MapSelector = null;
		private System.Windows.Forms.TrackBar maxPlayers;
		private System.Windows.Forms.TextBox nameBox;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label maxPlayersLabel;
		private System.Windows.Forms.Label maxPlayersValue;
		private System.Windows.Forms.Button buttonCreate;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Label SelectMapLabel;
		private ClientControls.Minimap Minimap;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBoxPort;
		private System.Windows.Forms.ErrorProvider errorProviderName;
		private System.Windows.Forms.ErrorProvider errorProviderPlayers;
		private System.Windows.Forms.ErrorProvider errorProviderPort;
		private System.Windows.Forms.ErrorProvider errorProviderMap;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox textBoxPassword;
		private System.Windows.Forms.ErrorProvider errorProviderPassword;
		private System.Windows.Forms.Button buttonTest;

		private class CEmpty
		{
			public CEmpty()
			{}
		}

		private CEmpty mutex = new CEmpty();

		private bool temp = false;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MapSelector.SMapInfo MapInfo
		{
			get
			{
				return MapSelector.MapInfo;
			}
		}

		public string BattleName
		{
			get
			{
				return nameBox.Text;
			}
		}

		public int MaxPlayers
		{
			get
			{
				return maxPlayers.Value;
			}
		}

		public string Mapname
		{
			get
			{
				return MapSelector.Mapname;
			}
		}

		public string Mapfilename
		{
			get
			{
				return MapSelector.Mapfilename;
			}
		}

		public int Port
		{
			get
			{
				return Convert.ToInt32(textBoxPort.Text);
			}
		}

		public string Password
		{
			get
			{
				return textBoxPassword.Text;
			}
		}

		public BattleHost()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			
			textBoxPort.Text = Global.DefaultBattlePort.ToString();
			MapSelector = new MapSelector(this.Minimap, SelectMapLabel);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(BattleHost));
			this.maxPlayers = new System.Windows.Forms.TrackBar();
			this.nameBox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.maxPlayersLabel = new System.Windows.Forms.Label();
			this.maxPlayersValue = new System.Windows.Forms.Label();
			this.buttonCreate = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.SelectMapLabel = new System.Windows.Forms.Label();
			this.Minimap = new ClientControls.Minimap();
			this.label2 = new System.Windows.Forms.Label();
			this.textBoxPort = new System.Windows.Forms.TextBox();
			this.errorProviderName = new System.Windows.Forms.ErrorProvider();
			this.errorProviderPlayers = new System.Windows.Forms.ErrorProvider();
			this.errorProviderPort = new System.Windows.Forms.ErrorProvider();
			this.errorProviderMap = new System.Windows.Forms.ErrorProvider();
			this.textBoxPassword = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.errorProviderPassword = new System.Windows.Forms.ErrorProvider();
			this.buttonTest = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.maxPlayers)).BeginInit();
			this.SuspendLayout();
			// 
			// maxPlayers
			// 
			this.maxPlayers.Location = new System.Drawing.Point(128, 64);
			this.maxPlayers.Maximum = 16;
			this.maxPlayers.Minimum = 2;
			this.maxPlayers.Name = "maxPlayers";
			this.maxPlayers.Size = new System.Drawing.Size(136, 45);
			this.maxPlayers.TabIndex = 1;
			this.maxPlayers.Value = 4;
			this.maxPlayers.Scroll += new System.EventHandler(this.maxPlayers_Scroll);
			// 
			// nameBox
			// 
			this.nameBox.Location = new System.Drawing.Point(128, 24);
			this.nameBox.Name = "nameBox";
			this.nameBox.Size = new System.Drawing.Size(128, 20);
			this.nameBox.TabIndex = 0;
			this.nameBox.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 24);
			this.label1.Name = "label1";
			this.label1.TabIndex = 2;
			this.label1.Text = "Battle Name";
			// 
			// maxPlayersLabel
			// 
			this.maxPlayersLabel.Location = new System.Drawing.Point(16, 64);
			this.maxPlayersLabel.Name = "maxPlayersLabel";
			this.maxPlayersLabel.Size = new System.Drawing.Size(104, 16);
			this.maxPlayersLabel.TabIndex = 3;
			this.maxPlayersLabel.Text = "Max Players";
			// 
			// maxPlayersValue
			// 
			this.maxPlayersValue.Location = new System.Drawing.Point(16, 80);
			this.maxPlayersValue.Name = "maxPlayersValue";
			this.maxPlayersValue.Size = new System.Drawing.Size(100, 16);
			this.maxPlayersValue.TabIndex = 4;
			// 
			// buttonCreate
			// 
			this.buttonCreate.Location = new System.Drawing.Point(24, 504);
			this.buttonCreate.Name = "buttonCreate";
			this.buttonCreate.TabIndex = 5;
			this.buttonCreate.Text = "Create";
			this.buttonCreate.Click += new System.EventHandler(this.buttonCreate_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(136, 504);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 6;
			this.buttonCancel.Text = "Cancel";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// SelectMapLabel
			// 
			this.SelectMapLabel.AutoSize = true;
			this.SelectMapLabel.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.SelectMapLabel.Location = new System.Drawing.Point(128, 480);
			this.SelectMapLabel.Name = "SelectMapLabel";
			this.SelectMapLabel.Size = new System.Drawing.Size(102, 16);
			this.SelectMapLabel.TabIndex = 999;
			this.SelectMapLabel.Text = "<No map selected>";
			this.SelectMapLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.SelectMapLabel.Click += new System.EventHandler(this.SelectMapLabel_Click);
			this.SelectMapLabel.Resize += new System.EventHandler(this.SelectMapLabel_Resize);
			// 
			// Minimap
			// 
			this.Minimap.Location = new System.Drawing.Point(48, 216);
			this.Minimap.Name = "Minimap";
			this.Minimap.Size = new System.Drawing.Size(256, 256);
			this.Minimap.TabIndex = 0;
			this.Minimap.TabStop = false;
			this.Minimap.Click += new System.EventHandler(this.Minimap_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 120);
			this.label2.Name = "label2";
			this.label2.TabIndex = 9;
			this.label2.Text = "Port";
			// 
			// textBoxPort
			// 
			this.textBoxPort.Location = new System.Drawing.Point(128, 120);
			this.textBoxPort.Name = "textBoxPort";
			this.textBoxPort.Size = new System.Drawing.Size(128, 20);
			this.textBoxPort.TabIndex = 3;
			this.textBoxPort.Text = "";
			// 
			// errorProviderName
			// 
			this.errorProviderName.ContainerControl = this;
			// 
			// errorProviderPlayers
			// 
			this.errorProviderPlayers.ContainerControl = this;
			// 
			// errorProviderPort
			// 
			this.errorProviderPort.ContainerControl = this;
			// 
			// errorProviderMap
			// 
			this.errorProviderMap.ContainerControl = this;
			// 
			// textBoxPassword
			// 
			this.textBoxPassword.Location = new System.Drawing.Point(128, 168);
			this.textBoxPassword.Name = "textBoxPassword";
			this.textBoxPassword.Size = new System.Drawing.Size(128, 20);
			this.textBoxPassword.TabIndex = 4;
			this.textBoxPassword.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 168);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 32);
			this.label3.TabIndex = 11;
			this.label3.Text = "Password (leave blank for none)";
			// 
			// errorProviderPassword
			// 
			this.errorProviderPassword.ContainerControl = this;
			// 
			// buttonTest
			// 
			this.buttonTest.Location = new System.Drawing.Point(248, 504);
			this.buttonTest.Name = "buttonTest";
			this.buttonTest.TabIndex = 1000;
			this.buttonTest.Text = "Test";
			this.buttonTest.Click += new System.EventHandler(this.buttonTest_Click);
			// 
			// BattleHost
			// 
			this.AcceptButton = this.buttonCreate;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(346, 544);
			this.Controls.Add(this.buttonTest);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.textBoxPassword);
			this.Controls.Add(this.textBoxPort);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.Minimap);
			this.Controls.Add(this.SelectMapLabel);
			this.Controls.Add(this.nameBox);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonCreate);
			this.Controls.Add(this.maxPlayersValue);
			this.Controls.Add(this.maxPlayersLabel);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.maxPlayers);
			this.Cursor = System.Windows.Forms.Cursors.Hand;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "BattleHost";
			this.Text = "BattleHost";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.BattleHost_Closing);
			this.Load += new System.EventHandler(this.BattleHost_Load);
			((System.ComponentModel.ISupportInitialize)(this.maxPlayers)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void BattleHost_Load(object sender, System.EventArgs e)
		{
			maxPlayersValue.Text = maxPlayers.Value.ToString();
		}

		private void maxPlayers_Scroll(object sender, System.EventArgs e)
		{
			maxPlayersValue.Text = maxPlayers.Value.ToString();
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			this.Close();
		}

		private void buttonCreate_Click(object sender, System.EventArgs e)
		{
			if ( ValidateName() && ValidatePort() && ValidateMap() )
			{
				DialogResult = DialogResult.OK;
				this.Close();
			}
		}

		private void SelectMapLabel_Click(object sender, System.EventArgs e)
		{
			MapSelector.Show();
			MapSelector.Location = new Point(this.Location.X+this.Width, this.Location.Y);
			MapSelector.Focus();
		}

		private void BattleHost_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			MapSelector.Close();
		}

		private void SelectMapLabel_Resize(object sender, System.EventArgs e)
		{
			Label label = (Label)sender;
			label.Location = new Point(this.Width/2 - label.Width/2, label.Location.Y);
		}

		private bool ValidateName()
		{
			if ( nameBox.TextLength == 0 )
			{
				errorProviderName.SetError(nameBox, "Name cannot be blank");
				return false;
			}

			else if ( nameBox.TextLength > CONSTANTS.MAXBATTLENAME )
			{
				errorProviderName.SetError(nameBox, string.Format("Name cannot exceed {0} characters", CONSTANTS.MAXBATTLENAME));
				return false;
			}

			else if ( Regex.Match(nameBox.Text, "[a-zA-Z0-9]*", RegexOptions.None).Value != nameBox.Text)
			{
				errorProviderName.SetError(nameBox, "Can only containg alphanumeric characters");
				return false;
			}
			// clear the error if one is already there
			errorProviderName.SetError(nameBox, "");
			return true;																			
		}

		private bool ValidatePort()
		{
			if ( textBoxPort.TextLength == 0 )
			{
				errorProviderPort.SetError(textBoxPort, "Port cannot be empty");
				return false;
			}
			else if ( Regex.Match(textBoxPort.Text, "[0-9]*", RegexOptions.None).Value != textBoxPort.Text ||
				textBoxPort.TextLength > 5 ||
				Convert.ToInt32(textBoxPort.Text, 10) > 65534 )
			{
				errorProviderName.SetError(textBoxPort, "Must be a number between 1 and 65534");
				return false;
			}
			// clear the error if one is already there
			errorProviderPort.SetError(textBoxPort, "");
			return true;
		}

		private bool ValidateMap()
		{
			if ( Mapname == "" )
			{
				errorProviderMap.SetError(SelectMapLabel, "Select a map.  Click the label");
				return false;
			}
			errorProviderMap.SetError(SelectMapLabel, "");
			return true;
		}

		private bool ValidatePassword()
		{
			if ( textBoxPassword.Text == "" )
			{
				return true;
			}
			if ( textBoxPassword.Text.Length > CONSTANTS.MAXPASSWD )
			{
				errorProviderPassword.SetError(textBoxPassword, string.Format("Password must be fewer than {0} characters", CONSTANTS.MAXPASSWD));
			}
			if ( Regex.Match(textBoxPassword.Text, "[a-zA-Z0-9]*", RegexOptions.None).Value != textBoxPassword.Text )
			{
				errorProviderPassword.SetError(textBoxPassword, "May contain only alphanumeric characters");
				return false;
			}
			return true;
		}

		private void Minimap_Click(object sender, System.EventArgs e)
		{
			MapSelector.Show();
			MapSelector.Location = new Point(this.Location.X+this.Width, this.Location.Y);
			MapSelector.Focus();
		}

		private void buttonTest_Click(object sender, System.EventArgs e)
		{
			try
			{
				if ( ValidatePort() )
				{
					buttonTest.Enabled = false;
				
					try
					{
						if ( Global.connMan != null )
						{
							byte[] msg = new byte[3];
							msg[0] = (byte)PACKETS.PACK_BATTLETEST;
							BitConverter.GetBytes((ushort)this.Port).CopyTo(msg, 1);
							Global.connMan.Send(msg);
						}
					}
					catch ( SocketException )
					{
						MessageBox.Show("Could not send message to master server");
					}

					ushort port = (ushort)Port;
					Socket m_Listener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
					m_Listener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
					// this is needed for when you disconnect then attempt to start a new battle room
					m_Listener.SetSocketOption(SocketOptionLevel.Socket,SocketOptionName.ReuseAddress, 1);
					m_Listener.Bind(new IPEndPoint(IPAddress.Any, port));
					m_Listener.Listen(32);
					lock ( mutex )
					{
						temp = false;
						m_Listener.BeginAccept(new AsyncCallback(TestAccept), m_Listener);
						Monitor.Wait(mutex, TimeSpan.FromSeconds(4.0));
					}
					
//					Thread.Sleep(TimeSpan.FromSeconds(4.0));
					m_Listener.Close();
					lock ( this )
					{
						if ( !temp )
						{
							MessageBox.Show("Failed.  You probably won't be able to host with these settings");
						}
					}

					buttonTest.Enabled = true;
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void TestAccept(IAsyncResult iar)
		{
			if ( iar.CompletedSynchronously )
			{
				MessageBox.Show("Success!  You should be able to host with these settings");
				lock ( mutex )
				{
					temp = true;
					Monitor.Pulse(mutex);
				}
			}
		}
	}
}
