// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the UTILITY_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// UTILITY_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef UTILITY_EXPORTS
#define UTILITY_API __declspec(dllexport)
#else
#define UTILITY_API __declspec(dllimport)
#endif

#pragma pack(1)
struct SM2Header
{
	char magic[8];
	int version;
	int xsize;
	int ysize;
	int tilesize;
	int numtiles;
	int tilesPtr;
	int tilemapPtr;
	int minimapPtr;
	int heightmapPtr;
	int metalmapPtr;
	int featurePtr;
};

struct MapInfo
{
	char* name;
	int tidalstrength;
	int gravity;
	float maxmetal;
	int extractorradius;
	int minwind;
	int maxwind;
};

#define RM	0x0000F800
#define GM  0x000007E0
#define BM  0x0000001F

#define RED_RGB565(x) ((x&RM)>>11)
#define GREEN_RGB565(x) ((x&GM)>>5)
#define BLUE_RGB565(x) (x&BM)
#define PACKRGB(r, g, b) (((r<<11)&RM) | ((g << 5)&GM) | (b&BM) )

extern "C" UTILITY_API void* GetMinimap(const char* filename, int miplevel);

extern "C" UTILITY_API bool GetMapinfo(const char* filename, MapInfo* outInfo);